events.listen('recipes', function (event) {

    var recipes = [
	
        shapedRecipe('enderstorage:ender_tank', ['ABA', 'CDC', 'AEA'], {
            A: 'minecraft:blaze_rod',
            B: '#forge:wool',
            C: 'minecraft:obsidian',
            D: 'minecraft:cauldron',
			E: 'botania:ender_air_bottle'
        }),
		
		shapedRecipe('forbidden_arcanus:orb_of_temporary_flight', [' A ', 'ABA', ' A '], {
            A: 'forbidden_arcanus:xpetrified_orb',
            B: 'forbidden_arcanus:golden_feather'
        }),
		
		shapedRecipe('botania:enchanted_soil', ['A  ', 'B  ', '   '], {
            A: 'botania:overgrowth_seed',
            B: 'minecraft:grass_block'
        }),
		
		shapedRecipe('kubejs:purifying_rune', ['AAA', 'ABA', 'AAA'], {
            A: '/relics:rune.+/',
            B: 'bountifulbaubles:spectral_silt'
        }),
		
		shapedRecipe('minecraft:chest', ['AAA', 'A A', 'AAA'], {
            A: ['/biomesoplenty:.+_planks/', '/byg:.+_planks/']
        }),
		
		shapedRecipe(Item.of('minecraft:tipped_arrow', 8, {Potion:"mowziesmobs:long_poison_resist"}), ['AAA', 'ABA', 'AAA'], {
            A: 'minecraft:arrow',
            B: 'pandoras_creatures:acidic_archvine_tongue'
        }),
		
		shapedRecipe(Item.of('gaiadimension:keystone_block', 2), 
		[
		'ABA',
		'BCB',
		'ABA'
		], {
            A: 'gaiadimension:crystallized_lapis_lazuli',
            B: 'gaiadimension:crystallized_redstone',
            C: 'botania:life_essence'
        }),
		
		shapedRecipe('ironfurnaces:netherite_furnace', 
		[
		'ABA',
		'BCB',
		'ADA'
		], {
            A: 'minecraft:netherite_ingot',
            B: 'naturesaura:tainted_gold',
            C: 'ironfurnaces:obsidian_furnace',
            D: 'minecraft:netherite_block'
        }),
		
		shapedRecipe('ironfurnaces:item_heater', ['ABA', 'CDC', 'ABA'], {
            A: 'quark:basalt',
            B: 'create:polished_rose_quartz',
			C: 'create:shadow_steel',
			D: 'create:redstone_link'
        }),
		
		shapedRecipe('ironfurnaces:heater', ['ABA', 'CDC', 'AEA'], {
            A: 'quark:basalt',
            B: 'create:redstone_link',
			C: 'immersiveengineering:furnace_heater',
			D: 'create:shadow_steel_casing',
			E: 'naturesaura:furnace_heater'
        }),
		
		shapedRecipe('ironfurnaces:rainbow_core', ['AAA', 'BAB', 'AAA'], {
            A: 'ironfurnaces:rainbow_plating',
            B: 'ironfurnaces:netherite_furnace'
        }),
		
		shapedRecipe('botania:forest_eye', ['ABA', 'BCB', 'ABA'], {
            A: 'botania:manasteel_ingot',
            B: 'botania:livingrock',
            C: 'upgrade_aquatic:elder_eye'
        }),
		
		shapedRecipe('cyclic:spawner_seeker', ['ABA', 'BCB', 'ABA'], {
            A: '#forge:dyes/purple',
            B: 'forbidden_arcanus:spawner_scrap',
            C: 'minecraft:ender_eye'
        }),
		
		shapedRecipe('engineerstools:redia_tool', ['AB ', 'CD ', '  E'], {
            A: 'mysticalworld:lead_axe',
            B: 'mysticalworld:lead_pickaxe',
            C: 'mysticalworld:lead_shovel',
            D: 'immersiveengineering:stick_treated',
			E: 'forbidden_arcanus:obsidian_ingot'
        }),
		
		shapedRecipe('scannable:scanner', ['ABA', 'CDC', 'CEC'], {
            A: 'minecraft:iron_ingot',
            B: 'botania:divining_rod',
            C: '#forge:ingots/nickel',
            D: 'naturesaura:netherite_finder',
			E: (Item.of('immersiveengineering:capacitor_lv').ignoreNBT())
        }),
		
		shapedRecipe('cyclic:evoker_fang', [
		'ABC',
		' DB',
		'D A'
		], {
            A: 'meetyourfight:mossy_tooth',
            B: 'druidcraft:amber_block',
            C: 'farlanders:endumium_block',
            D: 'evilcraft:dark_stick'
        }),
		
		//mgutils
		
		shapedRecipe('mob_grinding_utils:solid_xp_mould_baby', [
		'A A',
		'A A',
		'A A'
		], {
            A: 'tconstruct:blank_cast'
        }),
		
		shapedRecipe('mob_grinding_utils:gm_chicken_feed_cursed', [
		'ABA',
		'CDC',
		'ACA'
		], {
            A: 'astralsorcery:nocturnal_powder',
            B: 'minecraft:spider_eye',
            C: 'rats:contaminated_food',
            D: '#forge:seeds'
        }),
		
		shapedRecipe('mob_grinding_utils:fan', [
		'ABA',
		'BCB',
		'ABA'
		], {
            A: 'minecraft:redstone',
            B: 'immersiveengineering:ingot_nickel',
            C: 'botania:daffomill'
        }),
		
		shapedRecipe('mob_grinding_utils:saw', [
		'ABA',
		'BCB',
		'DED'
		], {
            A: Item.of('minecraft:diamond_sword', {Damage:0}),
            B: 'darkutils:rune_damage_player',
            C: 'botania:bellethorn',
			D: 'titanium:diamond_gear',
			E: 'minecraft:heavy_weighted_pressure_plate'
        }),
		
		shapedRecipe('mob_grinding_utils:tank_sink', [
		' A ',
		'BCB',
		' D '
		], {
            A: 'quark:grate',
            B: 'minecraft:ender_eye',
            C: 'minecraft:hopper',
			D: 'pneumaticcraft:small_tank'
        }),
		
		shapedRecipe('mob_grinding_utils:absorption_hopper', [
		'ABA',
		'BCB',
		'ADA'
		], {
            A: 'minecraft:obsidian',
            B: 'botania:hopperhock',
            C: 'quark:magnet',
			D: Item.of('evilcraft:dark_tank', {capacity:16000})
        }),
		
		shapedRecipe('mob_grinding_utils:xpsolidifier', [
		' A ',
		'BCB',
		' D '
		], {
            A: 'minecraft:piston',
            B: 'forbidden_arcanus:xpetrified_orb',
            C: 'minecraft:hopper',
			D: Item.of('evilcraft:dark_tank', {capacity:16000})
        }),
		
		shapedRecipe('mob_grinding_utils:absorption_upgrade', [
		'CAC',
		'ABA',
		'CAC'
		], {
            A: 'minecraft:ender_pearl',
            B: 'botania:hopperhock_chibi',
			C: Item.of('tconstruct:large_plate', {Material:"tconstruct:copper"})
        }),
		
		shapedRecipe('mob_grinding_utils:ender_inhibitor_on', [
		' A ',
		'BCB',
		' D '
		], {
            A: 'minecraft:redstone',
            B: 'minecraft:ender_eye',
			C: 'resourcefulbees:ender_beecon',
			D: 'charm:ender_pearl_block'
        }),
		
		//securityCraft
		
		shapedRecipe('securitycraft:portable_radar', [
		' A ',
		'ABA',
		' A '
		], {
            A: 'buildersaddition:entity_detector',
            B: 'minecraft:redstone'
        }),
		
		shapedRecipe('securitycraft:protecto', [
		'ABA',
		'ACA',
		'AAA'
		], {
            A: 'immersiveengineering:ingot_steel',
            B: 'securitycraft:portable_radar',
			C: 'evilcraft:environmental_accumulation_core'
        }),
		
		shapedRecipe('securitycraft:retinal_scanner', [
		'ABA',
		'ACA',
		'AAA'
		], {
            A: '#securitycraft:reinforced/stone',
            B: 'securitycraft:username_logger',
			C: 'quark:ender_watcher'
        }),
		
		shapedRecipe('securitycraft:sentry', [
		' B ',
		'ACA',
		'ADA'
		], {
            A: 'securitycraft:reinforced_iron_block',
            B: 'minecraft:dispenser',
			C: 'immersiveengineering:circuit_board',
			D: 'securitycraft:portable_radar'
        }),
		
		shapedRecipe(Item.of('trailmix:nyan_pig_launcher').toResultJson(), ['AAA', 'ABA', 'AAA'], {
            A: 'kubejs:uninspiring_rainbow_chunk',
			B: Item.of('trailmix:tmpp_launcher').toResultJson()
        }),
		
		shapedRecipe('druidcraft:crate', ['ABA', 'B B', 'ABA'], {
            A: '#minecraft:planks',
            B: 'druidcraft:rockroot'
        }),
		
		shapedRecipe('snailmail:snail_box', ['AAA', 'ABA', 'AAA'], {
            A: 'autumnity:snail_shell_piece',
            B: 'minecraft:nautilus_shell'
        }),
		
		shapedRecipe('bountifulbaubles:ring_overclocking', ['ABA', 'B B', 'ABA'], {
            A: 'minecraft:lapis_block',
            B: '#forge:ingots/quicksilver'
        }),
		
		shapedRecipe('whisperwoods:hand_of_fate', ['   ', ' A ', 'BBB'], {
            A: 'kubejs:claw',
            B: 'minecraft:stone_slab'
        }),
		
		shapedRecipe('cyclic:fisher', ['ABA', 'BCB', 'ABA'], {
            A: 'undergarden:wigglewood_planks',
            B: 'minecraft:cobweb',
            C: 'aquaculture:neptunes_bounty'
        }),
		
		shapedRecipe('cyclic:terra_preta', ['AAA', 'ABA', 'AAA'], {
            A: 'minecraft:podzol',
            B: 'farmingforblockheads:red_fertilizer'
        }),
		
		shapedRecipe('cyclic:apple_honey', ['AAA', 'ABA', 'AAA'], {
            A: 'minecraft:honey_block',
            B: 'minecraft:apple'
        }),
		
		shapedRecipe(Item.of('cyclic:dark_glass', 8), ['AAA', 'ABA', 'AAA'], {
            A: 'industrialforegoing:dark_glass',
            B: 'forbidden_arcanus:dark_nether_star'
        }),
		
		shapedRecipe('javd:portal_block', ['AAA', 'ABA', 'AAA'], {
            A: 'quark:basalt',
            B: 'charm:ender_pearl_block'
        }),
		
		shapedRecipe('druidcraft:growth_lamp', ['ABA', 'BCB', 'ABA'], {
			A: 'druidcraft:rockroot',
			B: 'minecraft:emerald',
			C: 'naturesaura:spawn_lamp'
		}),
		
		shapedRecipe('undergarden:catalyst', ['ABA', 'BCB', 'ABA'], {
			A: 'minecraft:gold_ingot',
			B: 'mysticalworld:quicksilver_ingot',
			C: 'naturesaura:sky_ingot'
		}),
		
		shapedRecipe('xreliquary:fertile_lily_pad', ['ABA', 'BCB', 'ABA'], {
			A: 'botania:fertilizer',
			B: 'xreliquary:fertile_essence',
			C: 'minecraft:lily_pad'
		}),
		
		shapedRecipe('cyclic:water_candle', [' A ', 'BAB', 'BCB'], {
			A: '#forge:storage_blocks/lapis',
			B: 'astralsorcery:nocturnal_powder',
			C: 'minecraft:light_weighted_pressure_plate'
		}),
		
		shapedRecipe('cyclic:ender_eye_reuse', ['ABA', 'BAB', 'ABA'], {
            A: 'minecraft:ender_eye',
            B: 'forbidden_arcanus:stellarite_piece'
        }),
		
		shapedRecipe('kubejs:diorite_alloy', ['AB ', 'BA ', '   '], {
            A: ['#forge:nuggets/iron', '#forge:nuggets/zinc'],
            B: 'minecraft:diorite'
        }),
		
		
		shapedRecipe(Item.of('engineersdecor:metal_bar', 6), ['  A', ' A ', 'A  '], {
			A: 'immersiveengineering:stick_iron'
		}),
		
		shapedRecipe(Item.of('immersiveengineering:stick_treated', 4), ['A  ', 'A  ', '   '], {
			A: 'immersiveengineering:treated_wood_horizontal'
		}),
		
		shapedRecipe('immersiveengineering:stick_steel', ['A  ', 'A  ', '   '], {
			A: '#forge:ingots/steel'
		}),
		
		//lootbags
		
		shapedRecipe('kubejs:affixgear2', ['AAA', 'ABA', 'AAA'], {
            A: ['minecraft:zombie_head', 'minecraft:creeper_head', '/minecraft:player_head/', 'minecraft:skeleton_skull', 'minecraft:wither_skeleton_skull'],
            B: 'forbidden_arcanus:rune_bag'
        }),
		shapedRecipe('kubejs:affixgear3', ['CDC', 'ABA', 'CAC'], {
            A: 'more_jellyfish:emerald_fragment',
            B: 'kubejs:affixgear2',
			C: 'bountifulbaubles:spectral_silt',
			D: 'forbidden_arcanus:dark_rune'
        }),
		shapedRecipe('kubejs:affixgear4', ['CDC', 'ABA', 'CAC'], {
            A: 'more_jellyfish:diamond_fragment',
            B: 'kubejs:affixgear3',
			C: 'bountifulbaubles:spectral_silt',
			D: 'forbidden_arcanus:dark_rune'
        }),
		shapedRecipe('kubejs:affixgear5', ['CAC', 'ABA', 'CAC'], {
            A: 'gaiadimension:proustite',
            B: 'kubejs:affixgear4',
			C: 'gaiadimension:carnelian'
        }),
    ];
    recipes.forEach(function (recipe) {
        event.shaped(recipe.result, recipe.pattern, recipe.key);
    });
});